package nodatafound.utshared;

import java.lang.reflect.Field;

import org.junit.jupiter.api.extension.AfterEachCallback;
import org.junit.jupiter.api.extension.ExtensionContext;

public class AutoCloseableExtension implements AfterEachCallback {

  @Override
  public void afterEach(final ExtensionContext context) throws Exception {
    final Object instance = context.getRequiredTestInstance();
    final AutoCloseableUnits units = new AutoCloseableUnits();
    for (final Field field : context.getRequiredTestClass().getFields()) {
      if (AutoCloseable.class.isAssignableFrom(field.getType())) {
        units.add(field, (AutoCloseable) field.get(instance));
      }
    }
    units.close();
  }

}